#!/bin/bash

if [ "$1" = "-q" ]; then
   exec > /dev/null 2> /dev/null
fi

if [ -s /var/lib/mervis/sharkrt.lic ]; then
    if grep -i -e "RT License" -e "RT is not licensed" -e "DEMO mode" /var/lib/mervis/mervisrt.default.log | tail -1 \
       | grep -q -e " ERR " -e " WRN "; then
        echo "Looks like unlicensed.."
        do_load=1
        #echo "$do_load"
    fi
else
    do_load=1
fi
if [ "$do_load" = "1" ]; then
    # try load from mmcboot1
    if [ -b "$(readlink /run/unipi-plc/by-sys/nvmem)" ]; then
        mdir="$(mktemp -d)"
        if mount "$(readlink /run/unipi-plc/by-sys/nvmem)" "$mdir" -o ro 2>/dev/null; then
            if [ -s "$mdir/mervis/sharkrt.lic" ]; then
                cp "$mdir/mervis/sharkrt.lic" /var/lib/mervis/sharkrt.lic
                unset do_load
            fi
            umount "$mdir"
        fi
        rmdir "$mdir" || true
    fi
fi
if [ "$do_load" = "1" ]; then
    # try load from unipi modbus
    #echo "Try modbus..."
    if /opt/unipi/tools/r2k -p 503 -r > /tmp/r2k.file 2>/dev/null ; then
        if [ -s /tmp/r2k.file ]; then
            mv -f /tmp/r2k.file /var/lib/mervis/sharkrt.lic
            unset do_load
        fi
    fi
    rm -f /tmp/r2k.file
fi
